
clear all
nntwarn off
% format long
format compact
% load dane_norm ;
load wino5 ;
% load data1.txt
% P=data1(:,1:3);
% T=data1(:,4)';

% maxP=max(P);
% minP=min(P);
% Pn=zeros(size(P));
% for i=1:length(maxP),
%     Pn(:,i) = (1-(-1))*(P(:,i)-minP(i))/(maxP(i)-minP(i)) + (-1);
% %     (ymax-ymin)*(x-xmin)/(xmax-xmin) + ymin;
% end

% Pn = Pn';
P=Pn;
%T = Tn;
[R,Q] = size(P);
[S3,Q] = size(T);
S1 = 3; %for
S2 = 1 ; %for

[W1,B1] = nwtan(S1,R);
[W2,B2] = nwtan(S2,S1);
[W3,B3] = rands(S3,S2);


disp_freq=100;      
max_epoch=20000;    
err_goal=.25;     
lr=1e-3; %for 
error = [];        


for epoch=1:max_epoch,
   
    A1 = tansig(W1*Pn,B1);
    A2 = tansig(W2*A1,B2);
    A3 = purelin(W3*A2,B3);
    E = T -A3;

    D3 = deltalin(A3,E);
    D2 = deltatan(A2,D3,W3);
    D1 = deltatan(A1,D2,W2);   
    
    

    [dW1,dB1] = learnbp(Pn,D1,lr);
    W1 = W1 + dW1;
    B1 = B1 + dB1;
    [dW2,dB2] = learnbp(A1,D2,lr);
    W2 = W2 + dW2;
    B2 = B2 + dB2;
    [dW3,dB3] = learnbp(A2,D3,lr);
    W3 = W3 + dW3;
    B3 = B3 + dB3;
 
    SSE = sumsqr(E);
    error = [error SSE];
   
   
    if SSE < err_goal,
        epoch = epoch - 1;
        break,
    end,
    
   

    if(rem(epoch,disp_freq)==0)
        epoch
        SSE
%        plot(P,T,'r',P,A3,'g')
       plot([1:length(T)],T,'r',[1:length(T)],A3,'g')
      % plot(error)
      
        pause(1e-100)
    end 
end
%mc
epoch
SSE
[T' A3' (T-A3)' (abs(T-A3)>.5)']
100*(1-sum((abs(T-A3)>.5)')/length(T))
